# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Public Classes

* [`osquery`](#osquery): osquery

#### Private Classes

* `osquery::config`: osquery configuration
* `osquery::package`: osquery package management
* `osquery::service`: osquery service management

## Classes

### <a name="osquery"></a>`osquery`

osquery

#### Parameters

The following parameters are available in the `osquery` class:

* [`config_path`](#config_path)
* [`config_owner`](#config_owner)
* [`config_group`](#config_group)
* [`package_name`](#package_name)
* [`package_ensure`](#package_ensure)
* [`service_name`](#service_name)
* [`service_enable`](#service_enable)
* [`service_ensure`](#service_ensure)
* [`manage_repo`](#manage_repo)
* [`repo_url`](#repo_url)
* [`repo_key_id`](#repo_key_id)
* [`repo_key_server`](#repo_key_server)
* [`settings`](#settings)

##### <a name="config_path"></a>`config_path`

Data type: `Stdlib::AbsolutePath`

The absolute path to the osquery configuration file

Default value: `'/etc/osquery/osquery.conf'`

##### <a name="config_owner"></a>`config_owner`

Data type: `Variant[Integer[0], String[1]]`

The owner to set on the osquery configuration file

Default value: `0`

##### <a name="config_group"></a>`config_group`

Data type: `Variant[Integer[0], String[1]]`

The group to set on the osquery configuration file

Default value: `0`

##### <a name="package_name"></a>`package_name`

Data type: `String[1]`

The osquery package name

Default value: `'osquery'`

##### <a name="package_ensure"></a>`package_ensure`

Data type: `String`

The osquery package ensure state

Default value: `'installed'`

##### <a name="service_name"></a>`service_name`

Data type: `String[1]`

The osquery service name

Default value: `'osqueryd'`

##### <a name="service_enable"></a>`service_enable`

Data type: `Boolean`

The osquery service enable state

Default value: ``true``

##### <a name="service_ensure"></a>`service_ensure`

Data type: `Stdlib::Ensure::Service`

The osquery service ensure state

Default value: `'running'`

##### <a name="manage_repo"></a>`manage_repo`

Data type: `Boolean`

Set to true to manage the osquery repository

Default value: ``true``

##### <a name="repo_url"></a>`repo_url`

Data type: `String`

The osquery repository URL to use

Default value: ``undef``

##### <a name="repo_key_id"></a>`repo_key_id`

Data type: `Optional[String]`

The osquery repository GPG key id (apt)

Default value: ``undef``

##### <a name="repo_key_server"></a>`repo_key_server`

Data type: `Optional[String]`

The osquery GPG key server (apt) or GPG URL (yum)

Default value: ``undef``

##### <a name="settings"></a>`settings`

Data type: `Hash`

A hash of settings to set in the osquery configuration file

Default value: `{}`

